Bug 244187 - hald slows down system clock on systems with apm
hald slows down system clock on systems with apm
Status: CLOSED NOTABUG
Product: Fedora
Classification: Fedora
Component: hal (Show other bugs)
7
All Linux
low Severity low
: ---
: ---
Assigned To: David Zeuthen
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2007-06-14 09:14 EDT by nvwarr
Modified: 2013-03-05 22:51 EST (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2008-05-30 07:30:57 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description nvwarr 2007-06-14 09:14:37 EDT
Description of problem:
hald reads /proc/apm every 2 seconds, which causes the system clock to slow down.

Version-Release number of selected component (if applicable):
hal-0.5.9-8.fc7

How reproducible:
Always

Steps to Reproduce:
1. Stop hald.
2. System clock runs normally.
3. Restart hald.
4. System clock runs slow.
  
Actual results:
Hald slows down the system clock to such an extent and with such a large jitter
that ntp is no longer able to keep the system time synchronized, resulting in
massive clock drifts (i.e. hours). On my system, the slowdown was about 10 hours
per week.

Expected results:
Hald shouldn't slow down the system clock.

Additional info:
Actually, this is really a kernel bug, because any user can cat /proc/apm, which
has the same effect. I have filed a bug report against the kernel package too
(see https://bugzilla.redhat.com/bugzilla/show_bug.cgi?id=244177). However, this
is not a new bug in the kernel and when it was reported against kernel 2.2.18
over six years ago, the thread ended with Erik Mouw suggesting caching the
results of /proc/apm and Alan Cox saying this is a userspace issue:
http://www.ussg.iu.edu/hypermail/linux/kernel/0012.3/0669.html

In other words, unless the kernel people can fix the problem with /proc/apm,
userspace programs shouldn't read /proc/apm that frequently.

Commenting out lines 391 and 392 in hald/linux/apm.c (i.e. so read_from_apm is
no longer called) works around the problem.
Comment 1 Bug Zapper 2008-05-14 09:04:46 EDT
This message is a reminder that Fedora 7 is nearing the end of life. Approximately 30 (thirty) days from now Fedora will stop maintaining and issuing updates for Fedora 7. It is Fedora's policy to close all bug reports from releases that are no longer maintained. At that time this bug will be closed as WONTFIX if it remains open with a Fedora 'version' of '7'.

Package Maintainer: If you wish for this bug to remain open because you plan to fix it in a currently maintained version, simply change the 'version' to a later Fedora version prior to Fedora 7's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that we may not be able to fix it before Fedora 7 is end of life. If you would still like to see this bug fixed and are able to reproduce it against a later version of Fedora please change the 'version' of this bug. If you are unable to change the version, please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's lifetime, sometimes those efforts are overtaken by events. Often a more recent Fedora release includes newer upstream software that fixes bugs or makes them obsolete. If possible, it is recommended that you try the newest available Fedora distribution to see if your bug still exists.

Please read the Release Notes for the newest Fedora distribution to make sure it will meet your needs:
http://docs.fedoraproject.org/release-notes/

The process we are following is described here: http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 2 Richard Hughes 2008-05-30 07:30:57 EDT
We need /proc/apm for the battery and AC detection. It sounds like a kernel bug
that needs fixing, not HAL. Sorry.

Note You need to log in before you can comment on or make changes to this bug.